Tp::Client::AccountManagerInterface Class Reference

| Home · All Classes · All Namespaces · Modules · Functions · Files

Public Slots | Signals | Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
Tp::Client::AccountManagerInterface Class Reference
Account manager proxies

`#include <TelepathyQt/AccountManager>`

Inherits Tp::AbstractInterface.

## Public Slots
QDBusPendingReply < QDBusObjectPath > | CreateAccount (const QString &connectionManager, const QString &protocol, const QString &displayName, const QVariantMap &parameters, const QVariantMap &properties, int timeout=-1)

## Signals
void | AccountRemoved (const QDBusObjectPath &account)
void | AccountValidityChanged (const QDBusObjectPath &account, bool valid)
Signals inherited from Tp::AbstractInterface
void | propertiesChanged (const QVariantMap &changedProperties, const QStringList &invalidatedProperties)

## Public Member Functions
| AccountManagerInterface (const QString &busName, const QString &objectPath, QObject *parent=0)
| AccountManagerInterface (const QDBusConnection &connection, const QString &busName, const QString &objectPath, QObject *parent=0)
| AccountManagerInterface (Tp::DBusProxy *proxy)
Tp::PendingVariant * | requestPropertyInterfaces () const
Tp::PendingVariant * | requestPropertyValidAccounts () const
Tp::PendingVariant * | requestPropertyInvalidAccounts () const
Tp::PendingVariant * | requestPropertySupportedAccountProperties () const
Tp::PendingVariantMap * | requestAllProperties () const
Public Member Functions inherited from Tp::AbstractInterface
virtual | ~AbstractInterface ()
bool | isValid () const
QString | invalidationReason () const
QString | invalidationMessage () const
void | setMonitorProperties (bool monitorProperties)
bool | isMonitoringProperties () const

## Static Public Member Functions
static QLatin1String | staticInterfaceName ()

## Protected Member Functions
virtual void | invalidate (Tp::DBusProxy *, const QString &, const QString &)
Protected Member Functions inherited from Tp::AbstractInterface
| AbstractInterface (DBusProxy *proxy, const QLatin1String &interface)
| AbstractInterface (const QString &busName, const QString &path, const QLatin1String &interface, const QDBusConnection &connection, QObject *parent)
PendingVariant * | internalRequestProperty (const QString &name) const
PendingOperation * | internalSetProperty (const QString &name, const QVariant &newValue)
PendingVariantMap * | internalRequestAllProperties () const

## Additional Inherited Members
Protected Slots inherited from Tp::AbstractInterface

## Detailed Description

Proxy class providing a 1:1 mapping of the D-Bus interface "org.freedesktop.Telepathy.AccountManager".

## Constructor & Destructor Documentation

Tp::Client::AccountManagerInterface::AccountManagerInterface | ( | const QString & | busName,
|  | const QString & | objectPath,
|  | QObject * | parent = `0`
| ) |  |

Creates a AccountManagerInterface associated with the given object on the session bus.

Parameters

  busName | Name of the service the object is on.
  objectPath | Path to the object on the service.
  parent | Passed to the parent class constructor.

Tp::Client::AccountManagerInterface::AccountManagerInterface | ( | const QDBusConnection & | connection,
|  | const QString & | busName,
|  | const QString & | objectPath,
|  | QObject * | parent = `0`
| ) |  |

Creates a AccountManagerInterface associated with the given object on the given bus.

Parameters

  connection | The bus via which the object can be reached.
  busName | Name of the service the object is on.
  objectPath | Path to the object on the service.
  parent | Passed to the parent class constructor.

Tp::Client::AccountManagerInterface::AccountManagerInterface | ( | Tp::DBusProxy * | proxy | ) |

Creates a AccountManagerInterface associated with the same object as the given proxy.

Parameters

  proxy | The proxy to use. It will also be the QObject::parent() for this object.

## Member Function Documentation

static QLatin1String Tp::Client::AccountManagerInterface::staticInterfaceName | ( |  | ) |
| inlinestatic

Returns the name of the interface "org.freedesktop.Telepathy.AccountManager", which this class represents.

Returns
  The D-Bus interface name.

Tp::PendingVariant* Tp::Client::AccountManagerInterface::requestPropertyInterfaces | ( |  | ) | const
| inline

Asynchronous getter for the remote object property `Interfaces` of type `QStringList`.

A list of the interfaces provided by the account manager object.

Returns
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariant* Tp::Client::AccountManagerInterface::requestPropertyValidAccounts | ( |  | ) | const
| inline

Asynchronous getter for the remote object property `ValidAccounts` of type `Tp::ObjectPathList`.

A list of the valid (complete, usable) Accounts. Change notification is via AccountValidityChanged. This split between valid and invalid accounts makes it easy to ignore the invalid ones. The only things that should be manipulating invalid accounts are account-editing UIs, which might be able to rescue them.

Returns
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariant* Tp::Client::AccountManagerInterface::requestPropertyInvalidAccounts | ( |  | ) | const
| inline

Asynchronous getter for the remote object property `InvalidAccounts` of type `Tp::ObjectPathList`.

A list of incomplete or otherwise unusable Accounts. Change notification is via AccountValidityChanged.

Returns
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariant* Tp::Client::AccountManagerInterface::requestPropertySupportedAccountProperties | ( |  | ) | const
| inline

Asynchronous getter for the remote object property `SupportedAccountProperties` of type `QStringList`.

A list of the fully qualified names of properties that can be set via the Properties argument to CreateAccount() when an account is created.

Examples of good properties to support here include AccountInterface::Icon , AccountInterface::Enabled , AccountInterface::Nickname , AccountInterface::AutomaticPresence , AccountInterface::ConnectAutomatically , AccountInterface::Supersedes , AccountInterface::RequestedPresence and AccountInterfaceAvatarInterface::Avatar .

Examples of properties that would make no sense here include AccountInterface::Valid , AccountInterface::Connection , AccountInterface::ConnectionStatus , AccountInterface::ConnectionStatusReason , AccountInterface::CurrentPresence and AccountInterface::NormalizedName .

This property MUST NOT include include the AccountInterface::DisplayName and AccountInterface::Parameters properties, which are set using separate arguments.

This property MAY include the names of properties that, after account creation, will be read-only: this indicates that the property can be set at account creation but not changed later.

For example, an account manager might support migration tools that use this to preserve the AccountInterface::HasBeenOnline property, even though that property is usually read-only.

Returns
  A pending variant which will emit finished when the property has been retrieved.

Tp::PendingVariantMap* Tp::Client::AccountManagerInterface::requestAllProperties | ( |  | ) | const
| inline

Request all of the DBus properties on the interface.

Returns
  A pending variant map which will emit finished when the properties have been retrieved.

QDBusPendingReply<QDBusObjectPath> Tp::Client::AccountManagerInterface::CreateAccount | ( | const QString & | connectionManager,
|  | const QString & | protocol,
|  | const QString & | displayName,
|  | const QVariantMap & | parameters,
|  | const QVariantMap & | properties,
|  | int | timeout = `-1`
| ) |  |
| inlineslot

Begins a call to the D-Bus method `CreateAccount` on the remote object.

Request the creation of a new Account. The account manager SHOULD NOT allow invalid accounts to be created.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters

  connectionManager |
      The name of the connection manager, e.g. &quot;salut&quot;.
  protocol |
      The protocol, e.g. &quot;local-xmpp&quot;.
  displayName |
      The initial value of the new account&apos;s DisplayName property.
      The account manager SHOULD modify this to make it unique if an
      Account already exists with the same display name, for instance by
      appending a number or the &apos;account&apos; parameter. Account
      manager implementations SHOULD accept an empty string, but account
      editing user interfaces should avoid passing an empty string for
      this parameter. The account creation UI may ask the user for a name
      for the new account. If the author of the UI chooses not to do
      this, the account creation UI is better able to suggest a default
      display name because it has protocol-specific knowledge which the
      account manager does not. The account manager always knows the
      complete list of accounts so it can easily tell whether it should
      append something to the display name to avoid presenting two
      identically-named accounts to the user.
  parameters |
      Initial parameter values, as would be passed to RequestConnection.
  properties | The values of any other properties to be set immediately on the new Account. Only the properties mentioned in SupportedAccountProperties are acceptable here. In particular, the AccountInterface::DisplayName and AccountInterface::Parameters properties are never allowed here, since they are set using the other arguments to this method. Account manager implementations SHOULD support creating accounts with an empty value for this argument.
  timeout | The timeout in milliseconds.

Returns

      The new Account.

void Tp::Client::AccountManagerInterface::AccountRemoved | ( | const QDBusObjectPath & | account | ) |
| signal

Represents the signal `AccountRemoved` on the remote object.

The given account has been removed. This is effectively change notification for the valid and invalid accounts lists. On emission of this signal, the Account indicated will no longer be present in either of the lists.

Parameters

  account |
      An Account, which must not be used any more.

void Tp::Client::AccountManagerInterface::AccountValidityChanged | ( | const QDBusObjectPath & | account,
|  | bool | valid
| ) |  |
| signal

Represents the signal `AccountValidityChanged` on the remote object.

The validity of the given account has changed. New accounts are also indicated by this signal, as an account validity change (usually to True) on an account that did not previously exist. This is effectively change notification for the valid and invalid accounts lists.

Parameters

  account |
      An Account.
  valid |
      True if the account is now valid.

void Tp::Client::AccountManagerInterface::invalidate | ( | Tp::DBusProxy * | proxy,
|  | const QString & | error,
|  | const QString & | message
| ) |  |
| protectedvirtual

Reimplemented from Tp::AbstractInterface.